"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _jwt = _interopRequireDefault(require("./jwt"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// role等级外部定义，可以精确role，也可以范围role
// 为了简化逻辑，精确和范围不能同时使用，精确只能是单值，不能传数组
var _default = ({
  token,
  role: exactRole,
  min: minRole,
  block
}) => {
  const _ref = token ? (0, _jwt.default)(token) : {},
        userRole = _ref.role;

  if (!userRole || exactRole && exactRole !== userRole || minRole && userRole < minRole) {
    if (block) {
      throw new Error('没有权限');
    } else {
      return false;
    }
  }

  return true;
};

exports.default = _default;