"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.dynamic = void 0;

var _fs = _interopRequireDefault(require("fs"));

var _path = _interopRequireDefault(require("path"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const dynamic = dir => {
  const define = (name, o) => Object.defineProperty(o, name, {
    get: require.bind(null, `./${dir}/${name}`)
  });

  return _fs.default.readdirSync(_path.default.join(__dirname, dir)).reduce((o, filename) => /\.js$/.test(filename) ? define(_path.default.basename(filename, '.js'), o) : o, {});
};

exports.dynamic = dynamic;

const load = (relate, relative, needObject, pre = '') => {
  const filenames = _fs.default.readdirSync(_path.default.resolve(relate, relative));

  if (needObject) {
    return Object.assign.apply(null, filenames.map(filename => {
      const key = pre + filename.substring(0, filename.length - 3);
      return /\.js$/.test(filename) ? {
        [key]: require(_path.default.resolve(relate, relative, filename)).default
      } : {};
    }));
  } else {
    return filenames.map(dirname => require(_path.default.resolve(relate, relative, dirname)).default);
  }
};

var _default = load;
exports.default = _default;